#include "init.h"

#define POCET_TEXTUR 1					
GLuint	texture[POCET_TEXTUR];
char	texture_name[POCET_TEXTUR][20]={"data/font.bmp"};

float	uholx,uholy,uholz,fps,fpsm,frame;
char	text[20];

void DrawGLScene(void)				// vlastn kreslenie
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	glLoadIdentity();				//Nahradi aktualnu maticu z identicku maticu
	glTranslatef(0.0f,0.0f,-5.0f);	//nasoby aktualnu maticu z transformacnou maticou - posunie pociatok
	
	glRotatef(uholx,1.0f,0.0f,0.0f);
	glRotatef(uholy,0,1,0);
	glRotatef(uholz,0,0,1);


	glColor3f(1.0f,1.0f,1.0f);		//biela farba	
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	glBegin(GL_QUADS);
		// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
		// Back Face
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
		// Top Face
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
		// Bottom Face
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
		// Right face
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);
		// Left Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);
	glEnd();
	
	fps=(float)1.0f /(float)TimerGetTime(&timer0);
	TimerReset(&timer0);
	gcvt( (double)fps, 3, text);
	glPrint_(0,0,"Actual FPS every frame:",0);
	glPrint_(27,0,text,0);

	if(TimerGetTime(&timer1)>0.5f)
	{
		fpsm= frame /(float)TimerGetTime(&timer1);
		TimerReset(&timer1);
		frame=0;
	}
	
	gcvt( (double)fpsm, 3, text);
	glPrint_(0,1,"Actual FPS every 500 ms:",0);
	glPrint_(27,1,text,0);	
	if(keys['H'])				//vypise help
	{
		glPrint_(1,3,"Program: Bitmap font and printing FPS (frames per second)",0);
		glColor3f(0.9f,0.9f,1.0f);
		glPrint_(13,4,"Programmer: Marek Mizanin - www.mizanin.szm.sk",0);
		glColor3f(1.0f,1.0f,1.0f);
		glPrint_(15,6,"Control keys:",0);
		glPrint_(20,7,"H - help",1);
	}
	frame+=1.0f;
	
	uholx+=0.2f;
	uholy+=0.3f;
	uholz+=0.4f;
}

AUX_RGBImageRec *LoadBMP(char *Filename)			// Natanie bitmapovho obrzka
{
	FILE *File=NULL;								// smernik na subor

	if (!Filename)return NULL;						// skka i meno sboru bolo zadan
	File=fopen(Filename,"r");						// otvorenie sboru na tanie
	if (File)										// existuje sbor ?
	{
		fclose(File);								// Uzatvorenie sbora
		return auxDIBImageLoad(Filename);			// Nata obrzok a vrti pointer
	}
	return NULL;									// Ak sa obrzok nenatal vrti NULL
}

int LoadGLTextures()								// Nata obrzky a uloi ako textury
{
	int Status=TRUE,i;								// indikator
	AUX_RGBImageRec *TextureImage;					// miesto pre truktru

	for(i=0;i<POCET_TEXTUR;i++)
	{	
		TextureImage=NULL;
		if (TextureImage=LoadBMP(texture_name[i]))
		{
			glGenTextures(1, &texture[i]);
			glBindTexture(GL_TEXTURE_2D, texture[i]);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage->sizeX, TextureImage->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->data);
		}
		else 
		{	MessageBox(NULL,"Chyba natania obrzka.",texture_name[i],MB_ICONERROR);Status=false;}

		if (TextureImage)									// Ak textura existuje
		{
			if (TextureImage->data)free(TextureImage->data);// ak existuju data uvoni z pamte
			free(TextureImage);								// uvoni truktru
		}
	}
	return Status;
}
